use_module([minisat,cnf,adder]) should_give true.

cnf(X==Y,Cnf) should_give variant(Cnf,
	[[T], [-X, Y, -T], [X, -Y, -T]]).

cnf((X*Y)+(-X*Z),Cnf) should_give variant(Cnf,
	[[T], [-T, T1, T2], [-T2, -X], [-T2, Z], [-T1, X], [-T1, Y]]).
	
sum([X+Y,X*Y,X==Y,X xor Y],[S1,S2,S3],Psi) should_give variant(Psi,
% This is what the paper says, but in reality it's a bit nested
%	(T1==X+Y) *(T2==(X==Y)) *(T3==T1 xor T2) *(T4==T1*T2) *(T5==X*Y)
%	*(T6==X xor Y) *(T7==T5 xor T6) *(T8==T5*T6) *(S1==T3 xor T7)
%	*(S2==T4 xor T8 xor (T3*T7)) *(S3==(T3*T7->T4+T8;T4*T8))
	(_G696==X+Y)
	* (_G702== (X==Y))
	* ((_G708==_G696 xor _G702)* (_G723==_G696*_G702))
	* ((_G747==X*Y)* (_G753==X xor Y)* ((_G759==_G747 xor _G753)* (_G774==_G747*_G753)))
	* ((S1==_G708 xor _G759)* ((S2==_G723 xor _G774 xor (_G708*_G759))* (S3== (_G708*_G759->_G723+_G774;_G723*_G774))))
    ).


cnf(X==Y,Cnf), solve(Cnf) should_give
	X==0, Y==0.

cnf(X==Y,Cnf), sat(Cnf) should_give
	true.

sum([X+Y,X*Y,X==Y,X xor Y],Sum,F), cnf(F,Cnf), solve(Cnf) should_give
	X == 0, Y == 0, Sum == [1, 0, 0].

sum([X+Y,X*Y,X==Y,X xor Y],[0,1,0],F), cnf(F,Cnf), solve(Cnf) should_give
%	X == 0, Y == 1.
	X == 1, Y == 0.	% depends on result order of term_variables/2

sum([X+Y,X*Y,X==Y,X xor Y],Sum,F), cnf(F,Cnf), maximize(Sum,Cnf), solve(Cnf) should_give
	Sum==[1,1,0], X==1, Y==1.


compile_term((partialMaxSat(Phi,Psi) :-
		sum(Psi,Max,SumPsi), cnf(Phi*SumPsi,Cnf), 
		maximize(Max,Cnf),   solve(Cnf)))
	should_give true.

partialMaxSat(X+Y,[X*Y,X==Y,X xor Y,-X+Y, -X, -Y, X]) should_give
	X == 1, Y == 1.
